/*
	CASIO Z-1/FX-890P emulator
	ˑ
*/

#ifndef DEPEND_H
#define DEPEND_H

#include <stdio.h>
#include <sys/stat.h>
#include "z1.h"
#include "SDL.h"

/* G~[g鑤̃L[ */
#if SDL_MAJOR_VERSION == 2
#define KEY_NONE	0
#define KEY_BACKSPACE	SDL_SCANCODE_BACKSPACE
#define KEY_TAB	SDL_SCANCODE_TAB
#define KEY_CLEAR	SDL_SCANCODE_NUMLOCKCLEAR
#define KEY_RETURN	SDL_SCANCODE_RETURN
#define KEY_PAUSE	SDL_SCANCODE_PAUSE
#define KEY_ESCAPE	SDL_SCANCODE_ESCAPE
#define KEY_SPACE	SDL_SCANCODE_SPACE
#define /*KEY_QUOTE*/KEY_COLON	SDL_SCANCODE_APOSTROPHE
#define KEY_COMMA	SDL_SCANCODE_COMMA
#define KEY_MINUS	SDL_SCANCODE_MINUS
#define KEY_PERIOD	SDL_SCANCODE_PERIOD
#define KEY_SLASH	SDL_SCANCODE_SLASH
#define KEY_0	SDL_SCANCODE_0
#define KEY_1	SDL_SCANCODE_1
#define KEY_2	SDL_SCANCODE_2
#define KEY_3	SDL_SCANCODE_3
#define KEY_4	SDL_SCANCODE_4
#define KEY_5	SDL_SCANCODE_5
#define KEY_6	SDL_SCANCODE_6
#define KEY_7	SDL_SCANCODE_7
#define KEY_8	SDL_SCANCODE_8
#define KEY_9	SDL_SCANCODE_9
#define KEY_SEMICOLON	SDL_SCANCODE_SEMICOLON
#define /*KEY_EQUALS*/KEY_HAT	SDL_SCANCODE_EQUALS
#define /*KEY_LEFTBRACKET*/KEY_AT	SDL_SCANCODE_LEFTBRACKET
#define /*KEY_BACKSLASH*/KEY_RIGHTBRACKET	SDL_SCANCODE_BACKSLASH
#define /*KEY_RIGHTBRACKET*/KEY_LEFTBRACKET	SDL_SCANCODE_RIGHTBRACKET
#define KEY_BACKQUOTE	SDL_SCANCODE_GRAVE
#define KEY_A	SDL_SCANCODE_A
#define KEY_B	SDL_SCANCODE_B
#define KEY_C	SDL_SCANCODE_C
#define KEY_D	SDL_SCANCODE_D
#define KEY_E	SDL_SCANCODE_E
#define KEY_F	SDL_SCANCODE_F
#define KEY_G	SDL_SCANCODE_G
#define KEY_H	SDL_SCANCODE_H
#define KEY_I	SDL_SCANCODE_I
#define KEY_J	SDL_SCANCODE_J
#define KEY_K	SDL_SCANCODE_K
#define KEY_L	SDL_SCANCODE_L
#define KEY_M	SDL_SCANCODE_M
#define KEY_N	SDL_SCANCODE_N
#define KEY_O	SDL_SCANCODE_O
#define KEY_P	SDL_SCANCODE_P
#define KEY_Q	SDL_SCANCODE_Q
#define KEY_R	SDL_SCANCODE_R
#define KEY_S	SDL_SCANCODE_S
#define KEY_T	SDL_SCANCODE_T
#define KEY_U	SDL_SCANCODE_U
#define KEY_V	SDL_SCANCODE_V
#define KEY_W	SDL_SCANCODE_W
#define KEY_X	SDL_SCANCODE_X
#define KEY_Y	SDL_SCANCODE_Y
#define KEY_Z	SDL_SCANCODE_Z
#define KEY_DELETE	SDL_SCANCODE_DELETE
#define KEY_KP0	SDL_SCANCODE_KP_0
#define KEY_KP1	SDL_SCANCODE_KP_1
#define KEY_KP2	SDL_SCANCODE_KP_2
#define KEY_KP3	SDL_SCANCODE_KP_3
#define KEY_KP4	SDL_SCANCODE_KP_4
#define KEY_KP5	SDL_SCANCODE_KP_5
#define KEY_KP6	SDL_SCANCODE_KP_6
#define KEY_KP7	SDL_SCANCODE_KP_7
#define KEY_KP8	SDL_SCANCODE_KP_8
#define KEY_KP9	SDL_SCANCODE_KP_9
#define KEY_KP_PERIOD	SDL_SCANCODE_KP_PERIOD
#define KEY_KP_DIVIDE	SDL_SCANCODE_KP_DIVIDE
#define KEY_KP_MULTIPLY	SDL_SCANCODE_KP_MULTIPLY
#define KEY_KP_MINUS	SDL_SCANCODE_KP_MINUS
#define KEY_KP_PLUS	SDL_SCANCODE_KP_PLUS
#define KEY_KP_ENTER	SDL_SCANCODE_KP_ENTER
#define KEY_KP_EQUALS	SDL_SCANCODE_KP_EQUALS
#define KEY_UP	SDL_SCANCODE_UP
#define KEY_DOWN	SDL_SCANCODE_DOWN
#define KEY_RIGHT	SDL_SCANCODE_RIGHT
#define KEY_LEFT	SDL_SCANCODE_LEFT
#define KEY_INSERT	SDL_SCANCODE_INSERT
#define KEY_HOME	SDL_SCANCODE_HOME
#define KEY_END	SDL_SCANCODE_END
#define KEY_PAGEUP	SDL_SCANCODE_PAGEUP
#define KEY_PAGEDOWN	SDL_SCANCODE_PAGEDOWN
#define KEY_F1	SDL_SCANCODE_F1
#define KEY_F2	SDL_SCANCODE_F2
#define KEY_F3	SDL_SCANCODE_F3
#define KEY_F4	SDL_SCANCODE_F4
#define KEY_F5	SDL_SCANCODE_F5
#define KEY_F6	SDL_SCANCODE_F6
#define KEY_F7	SDL_SCANCODE_F7
#define KEY_F8	SDL_SCANCODE_F8
#define KEY_F9	SDL_SCANCODE_F9
#define KEY_F10	SDL_SCANCODE_F10
#define KEY_F11	SDL_SCANCODE_F11
#define KEY_F12	SDL_SCANCODE_F12
#define KEY_F13	SDL_SCANCODE_F13
#define KEY_F14	SDL_SCANCODE_F14
#define KEY_F15	SDL_SCANCODE_F15
#define KEY_NUMLOCK	SDL_SCANCODE_NUMLOCKCLEAR
#define KEY_CAPSLOCK	SDL_SCANCODE_CAPSLOCK
#define KEY_SCROLLOCK	SDL_SCANCODE_SCROLLLOCK
#define KEY_RSHIFT	SDL_SCANCODE_RSHIFT
#define KEY_LSHIFT	SDL_SCANCODE_LSHIFT
#define KEY_RCTRL	SDL_SCANCODE_RCTRL
#define KEY_LCTRL	SDL_SCANCODE_LCTRL
#define KEY_RALT	SDL_SCANCODE_RALT
#define KEY_LALT	SDL_SCANCODE_LALT
#define KEY_MODE	SDL_SCANCODE_MODE
#define KEY_COMPOSE	SDL_SCANCODE_APPLICATION
#define KEY_HELP	SDL_SCANCODE_HELP
#define KEY_PRINT	SDL_SCANCODE_PRINTSCREEN
#define KEY_SYSREQ	SDL_SCANCODE_SYSREQ
#define KEY_BREAK	SDL_SCANCODE_STOP
#define KEY_MENU	SDL_SCANCODE_MENU
#define KEY_POWER	SDL_SCANCODE_POWER
#define KEY_UNDERSCORE	SDL_SCANCODE_INTERNATIONAL1
#define KEY_KANA	SDL_SCANCODE_INTERNATIONAL2
#define KEY_YEN	SDL_SCANCODE_INTERNATIONAL3
#define KEY_XFER	SDL_SCANCODE_INTERNATIONAL4
#define KEY_NFER	SDL_SCANCODE_INTERNATIONAL5
#define KEY_NONUSBACKSLASH	SDL_SCANCODE_NONUSBACKSLASH
#define KEY_LAST	SDL_NUM_SCANCODES
#elif SDL_MAJOR_VERSION == 1
#define KEY_NONE	0
#define KEY_BACKSPACE	SDLK_BACKSPACE
#define KEY_TAB	SDLK_TAB
#define KEY_CLEAR	SDLK_CLEAR
#define KEY_RETURN	SDLK_RETURN
#define KEY_PAUSE	SDLK_PAUSE
#define KEY_ESCAPE	SDLK_ESCAPE
#define KEY_SPACE	SDLK_SPACE
#define /*KEY_QUOTE*/KEY_COLON	SDLK_QUOTE
#define KEY_COMMA	SDLK_COMMA
#define KEY_MINUS	SDLK_MINUS
#define KEY_PERIOD	SDLK_PERIOD
#define KEY_SLASH	SDLK_SLASH
#define KEY_0	SDLK_0
#define KEY_1	SDLK_1
#define KEY_2	SDLK_2
#define KEY_3	SDLK_3
#define KEY_4	SDLK_4
#define KEY_5	SDLK_5
#define KEY_6	SDLK_6
#define KEY_7	SDLK_7
#define KEY_8	SDLK_8
#define KEY_9	SDLK_9
#define KEY_SEMICOLON	SDLK_SEMICOLON
#define /*KEY_EQUALS*/KEY_HAT	SDLK_EQUALS
#define /*KEY_LEFTBRACKET*/KEY_AT	SDLK_LEFTBRACKET
#define /*KEY_BACKSLASH*/KEY_RIGHTBRACKET	SDLK_BACKSLASH
#define /*KEY_RIGHTBRACKET*/KEY_LEFTBRACKET	SDLK_RIGHTBRACKET
#define KEY_BACKQUOTE	SDLK_BACKQUOTE
#define KEY_A	SDLK_a
#define KEY_B	SDLK_b
#define KEY_C	SDLK_c
#define KEY_D	SDLK_d
#define KEY_E	SDLK_e
#define KEY_F	SDLK_f
#define KEY_G	SDLK_g
#define KEY_H	SDLK_h
#define KEY_I	SDLK_i
#define KEY_J	SDLK_j
#define KEY_K	SDLK_k
#define KEY_L	SDLK_l
#define KEY_M	SDLK_m
#define KEY_N	SDLK_n
#define KEY_O	SDLK_o
#define KEY_P	SDLK_p
#define KEY_Q	SDLK_q
#define KEY_R	SDLK_r
#define KEY_S	SDLK_s
#define KEY_T	SDLK_t
#define KEY_U	SDLK_u
#define KEY_V	SDLK_v
#define KEY_W	SDLK_w
#define KEY_X	SDLK_x
#define KEY_Y	SDLK_y
#define KEY_Z	SDLK_z
#define KEY_DELETE	SDLK_DELETE
#define KEY_KP0	SDLK_KP0
#define KEY_KP1	SDLK_KP1
#define KEY_KP2	SDLK_KP2
#define KEY_KP3	SDLK_KP3
#define KEY_KP4	SDLK_KP4
#define KEY_KP5	SDLK_KP5
#define KEY_KP6	SDLK_KP6
#define KEY_KP7	SDLK_KP7
#define KEY_KP8	SDLK_KP8
#define KEY_KP9	SDLK_KP9
#define KEY_KP_PERIOD	SDLK_KP_PERIOD
#define KEY_KP_DIVIDE	SDLK_KP_DIVIDE
#define KEY_KP_MULTIPLY	SDLK_KP_MULTIPLY
#define KEY_KP_MINUS	SDLK_KP_MINUS
#define KEY_KP_PLUS	SDLK_KP_PLUS
#define KEY_KP_ENTER	SDLK_KP_ENTER
#define KEY_KP_EQUALS	SDLK_KP_EQUALS
#define KEY_UP	SDLK_UP
#define KEY_DOWN	SDLK_DOWN
#define KEY_RIGHT	SDLK_RIGHT
#define KEY_LEFT	SDLK_LEFT
#define KEY_INSERT	SDLK_INSERT
#define KEY_HOME	SDLK_HOME
#define KEY_END	SDLK_END
#define KEY_PAGEUP	SDLK_PAGEUP
#define KEY_PAGEDOWN	SDLK_PAGEDOWN
#define KEY_F1	SDLK_F1
#define KEY_F2	SDLK_F2
#define KEY_F3	SDLK_F3
#define KEY_F4	SDLK_F4
#define KEY_F5	SDLK_F5
#define KEY_F6	SDLK_F6
#define KEY_F7	SDLK_F7
#define KEY_F8	SDLK_F8
#define KEY_F9	SDLK_F9
#define KEY_F10	SDLK_F10
#define KEY_F11	SDLK_F11
#define KEY_F12	SDLK_F12
#define KEY_F13	SDLK_F13
#define KEY_F14	SDLK_F14
#define KEY_F15	SDLK_F15
#define KEY_NUMLOCK	SDLK_NUMLOCK
#define KEY_CAPSLOCK	SDLK_CAPSLOCK
#define KEY_SCROLLOCK	SDLK_SCROLLOCK
#define KEY_RSHIFT	SDLK_RSHIFT
#define KEY_LSHIFT	SDLK_LSHIFT
#define KEY_RCTRL	SDLK_RCTRL
#define KEY_LCTRL	SDLK_LCTRL
#define KEY_RALT	SDLK_RALT
#define KEY_LALT	SDLK_LALT
#define KEY_MODE	SDLK_MODE
#define KEY_COMPOSE	SDLK_COMPOSE
#define KEY_HELP	SDLK_HELP
#define KEY_PRINT	SDLK_PRINT
#define KEY_SYSREQ	SDLK_SYSREQ
#define KEY_BREAK	SDLK_BREAK
#define KEY_MENU	SDLK_MENU
#define KEY_POWER	SDLK_POWER
#define KEY_LAST	SDLK_LAST
#define KEY_UNDERSCORE	SDLK_UNDERSCORE
#define KEY_KANA	0
#define KEY_YEN	0
#define KEY_XFER	0
#define KEY_NFER	0
#define KEY_NONUSBACKSLASH	0
#endif

/* Rrl[VL[ */
#define KEYMOD_ALT	0x4000
#define KEYMOD_CTRL	0x8000
#define KEYMOD_SHIFT	0xc000
#define KEYMOD_MASK	0xc000

/* Oo */
#if SDL_MAJOR_VERSION == 2
#define log	SDL_Log
#elif SDL_MAJOR_VERSION == 1
#define log	printf
#endif

/* L[R[hϊe[u */
EXTERN uint16 keyConv[KEY_LAST + 1]
#if defined(DEF_GLOBAL)
= {
#if SDL_MAJOR_VERSION == 2
	/* 0x00 */
	0,	/* SDL_SCANCODE_UNKNOWN */
	0,
	0,
	0,
	ZKEY_A,	/* SDL_SCANCODE_A */
	ZKEY_B,	/* SDL_SCANCODE_B */
	ZKEY_C,	/* SDL_SCANCODE_C */
	ZKEY_D,	/* SDL_SCANCODE_D */
	/* 0x08 */
	ZKEY_E,	/* SDL_SCANCODE_E */
	ZKEY_F,	/* SDL_SCANCODE_F */
	ZKEY_G,	/* SDL_SCANCODE_G */
	ZKEY_H,	/* SDL_SCANCODE_H */
	ZKEY_I,	/* SDL_SCANCODE_I */
	ZKEY_J,	/* SDL_SCANCODE_J */
	ZKEY_K,	/* SDL_SCANCODE_K */
	ZKEY_L,	/* SDL_SCANCODE_L */
	/* 0x10 */
	ZKEY_M,	/* SDL_SCANCODE_M */
	ZKEY_N,	/* SDL_SCANCODE_N */
	ZKEY_O,	/* SDL_SCANCODE_O */
	ZKEY_P,	/* SDL_SCANCODE_P */
	ZKEY_Q,	/* SDL_SCANCODE_Q */
	ZKEY_R,	/* SDL_SCANCODE_R */
	ZKEY_S,	/* SDL_SCANCODE_S */
	ZKEY_T,	/* SDL_SCANCODE_T */
	/* 0x18 */
	ZKEY_U,	/* SDL_SCANCODE_U */
	ZKEY_V,	/* SDL_SCANCODE_V */
	ZKEY_W,	/* SDL_SCANCODE_W */
	ZKEY_X,	/* SDL_SCANCODE_X */
	ZKEY_Y,	/* SDL_SCANCODE_Y */
	ZKEY_Z,	/* SDL_SCANCODE_Z */
	ZKEY_1,	/* SDL_SCANCODE_1 */
	ZKEY_2,	/* SDL_SCANCODE_2 */
	/* 0x20 */
	ZKEY_3,	/* SDL_SCANCODE_3 */
	ZKEY_4,	/* SDL_SCANCODE_4 */
	ZKEY_5,	/* SDL_SCANCODE_5 */
	ZKEY_6,	/* SDL_SCANCODE_6 */
	ZKEY_7,	/* SDL_SCANCODE_7 */
	ZKEY_8,	/* SDL_SCANCODE_8 */
	ZKEY_9,	/* SDL_SCANCODE_9 */
	ZKEY_0,	/* SDL_SCANCODE_0 */
	/* 0x28 */
	ZKEY_RETURN,	/* SDL_SCANCODE_RETURN */
	ZKEY_OFF,	/* SDL_SCANCODE_ESCAPE */
	ZKEY_BS,	/* SDL_SCANCODE_BACKSPACE */
	ZKEY_TAB,	/* SDL_SCANCODE_TAB */
	ZKEY_SPC,	/* SDL_SCANCODE_SPACE */
	ZKEY_MINUS,	/* SDL_SCANCODE_MINUS */
	ZKEY_HAT,	/* SDL_SCANCODE_EQUALS */
	0,	/* SDL_SCANCODE_LEFTBRACKET */
	/* 0x30 */
	ZKEY_LPAREN,	/* SDL_SCANCODE_RIGHTBRACKET */
	ZKEY_RPAREN,	/* SDL_SCANCODE_BACKSLASH */
	ZKEY_SLASH,	/* SDL_SCANCODE_NONUSLASH */
	ZKEY_SEMICOLON,	/* SDL_SCANCODE_SEMICOLON */
	ZKEY_COLON,	/* SDL_SCANCODE_APOSTROPHE */
	0,	/* SDL_SCANCODE_GRAVE */
	ZKEY_COMMA,	/* SDL_SCANCODE_COMMA */
	ZKEY_PERIOD,	/* SDL_SCANCODE_PERIOD */
	/* 0x38 */
	ZKEY_SLASH,	/* SDL_SCANCODE_SLASH */
	ZKEY_CAPS,	/* SDL_SCANCODE_CAPSLOCK */
	0,	/* SDL_SCANCODE_F1 */
	0,	/* SDL_SCANCODE_F2 */
	0,	/* SDL_SCANCODE_F3 */
	0,	/* SDL_SCANCODE_F4 */
	0,	/* SDL_SCANCODE_F5 */
	0,	/* SDL_SCANCODE_F6 */
	/* 0x40 */
	0,	/* SDL_SCANCODE_F7 */
	0,	/* SDL_SCANCODE_F8 */
	0,	/* SDL_SCANCODE_F9 */
	0,	/* SDL_SCANCODE_F10 */
	0,	/* SDL_SCANCODE_F11 */
	0,	/* SDL_SCANCODE_F12 */
	0,	/* SDL_SCANCODE_PRINTSCREEN */
	0,	/* SDL_SCANCODE_SCROLLLOCK */
	/* 0x48 */
	ZKEY_BRK,	/* SDL_SCANCODE_PAUSE */
	ZKEY_INS,	/* SDL_SCANCODE_INSERT */
	ZKEY_CLS,	/* SDL_SCANCODE_HOME */
	0,	/* SDL_SCANCODE_PAGEUP */
	ZKEY_DEL,	/* SDL_SCANCODE_DELETE */
	0,	/* SDL_SCANCODE_END */
	0,	/* SDL_SCANCODE_PAGEDOWN */
	ZKEY_RIGHT,	/* SDL_SCANCODE_RIGHT */
	/* 0x50 */
	ZKEY_LEFT,	/* SDL_SCANCODE_LEFT */
	ZKEY_DOWN,	/* SDL_SCANCODE_DOWN */
	ZKEY_UP,	/* SDL_SCANCODE_UP */
	0,	/* SDL_SCANCODE_NUMLOCKCLEAR */
	ZKEY_SLASH,	/* SDL_SCANCODE_KP_DIVIDE */
	ZKEY_ASTER,	/* SDL_SCANCODE_KP_MULTIPLY */
	ZKEY_MINUS,	/* SDL_SCANCODE_KP_MINUS */
	ZKEY_PLUS,	/* SDL_SCANCODE_KP_PLUS */
	/* 0x58 */
	ZKEY_RETURN,	/* SDL_SCANCODE_KP_ENTER */
	ZKEY_1,	/* SDL_SCANCODE_KP_1 */
	ZKEY_2,	/* SDL_SCANCODE_KP_2 */
	ZKEY_3,	/* SDL_SCANCODE_KP_3 */
	ZKEY_4,	/* SDL_SCANCODE_KP_4 */
	ZKEY_5,	/* SDL_SCANCODE_KP_5 */
	ZKEY_6,	/* SDL_SCANCODE_KP_6 */
	ZKEY_7,	/* SDL_SCANCODE_KP_7 */
	/* 0x60 */
	ZKEY_8,	/* SDL_SCANCODE_KP_8 */
	ZKEY_9,	/* SDL_SCANCODE_KP_9 */
	ZKEY_0,	/* SDL_SCANCODE_KP_0 */
	ZKEY_PERIOD,	/* SDL_SCANCODE_KP_PERIOD */
	0,	/* SDL_SCANCODE_NONUSBACKSLASH */
	ZKEY_MENU,	/* SDL_SCANCODE_APPLICATION */
	ZKEY_BRK,	/* SDL_SCANCODE_POWER */
	ZKEY_EQUAL,	/* SDL_SCANCODE_KP_EQUALS */
	/* 0x68 */
	0,	/* SDL_SCANCODE_F13 */
	0,	/* SDL_SCANCODE_F14 */
	0,	/* SDL_SCANCODE_F15 */
	0,	/* SDL_SCANCODE_F16 */
	0,	/* SDL_SCANCODE_F17 */
	0,	/* SDL_SCANCODE_F18 */
	0,	/* SDL_SCANCODE_F19 */
	0,	/* SDL_SCANCODE_F20 */
	/* 0x70 */
	0,	/* SDL_SCANCODE_F21 */
	0,	/* SDL_SCANCODE_F22 */
	0,	/* SDL_SCANCODE_F23 */
	0,	/* SDL_SCANCODE_F24 */
	0,	/* SDL_SCANCODE_EXECUTE */
	0,	/* SDL_SCANCODE_HELP */
	ZKEY_MENU,	/* SDL_SCANCODE_MENU */
	0,	/* SDL_SCANCODE_SELECT */
	/* 0x78 */
	ZKEY_BRK,	/* SDL_SCANCODE_STOP */
	0,	/* SDL_SCANCODE_AGAIN */
	0,	/* SDL_SCANCODE_UNDO */
	0,	/* SDL_SCANCODE_CUT */
	0,	/* SDL_SCANCODE_COPY */
	0,	/* SDL_SCANCODE_PASTE */
	0,	/* SDL_SCANCODE_FIND */
	0,	/* SDL_SCANCODE_MUTE */
	/* 0x80 */
	0,	/* SDL_SCANCODE_VOLUMEUP */
	0,	/* SDL_SCANCODE_VOLUMEDOWN */
	0,
	0,
	0,
	ZKEY_COMMA,	/* SDL_SCANCODE_KP_COMMA */
	ZKEY_EQUAL,	/* SDL_SCANCODE_KP_EQUALSAS400 */
	0,	/* SDL_SCANCODE_INTERNATIONAL1 */
	/* 0x88 */
	0,	/* SDL_SCANCODE_INTERNATIONAL2 */
	0,	/* SDL_SCANCODE_INTERNATIONAL3 */
	0,	/* SDL_SCANCODE_INTERNATIONAL4 */
	0,	/* SDL_SCANCODE_INTERNATIONAL5 */
	0,	/* SDL_SCANCODE_INTERNATIONAL6 */
	0,	/* SDL_SCANCODE_INTERNATIONAL7 */
	0,	/* SDL_SCANCODE_INTERNATIONAL8 */
	0,	/* SDL_SCANCODE_INTERNATIONAL9 */
	/* 0x90 */
	0,	/* SDL_SCANCODE_LANG1 */
	0,	/* SDL_SCANCODE_LANG2 */
	0,	/* SDL_SCANCODE_LANG3 */
	0,	/* SDL_SCANCODE_LANG4 */
	0,	/* SDL_SCANCODE_LANG5 */
	0,	/* SDL_SCANCODE_LANG6 */
	0,	/* SDL_SCANCODE_LANG7 */
	0,	/* SDL_SCANCODE_LANG8 */
	/* 0x98 */
	0,	/* SDL_SCANCODE_LANG9 */
	0,	/* SDL_SCANCODE_ALTERASE */
	0,	/* SDL_SCANCODE_SYSREQ */
	0,	/* SDL_SCANCODE_CANCEL */
	ZKEY_CLS,	/* SDL_SCANCODE_CLEAR */
	0,	/* SDL_SCANCODE_PRIOR */
	ZKEY_RETURN,	/* SDL_SCANCODE_RETURN2 */
	0,	/* SDL_SCANCODE_SEPARATOR */
	/* 0xa0 */
	0,	/* SDL_SCANCODE_OUT */
	0,	/* SDL_SCANCODE_OPER */
	0,	/* SDL_SCANCODE_CLEARAGAIN */
	0,	/* SDL_SCANCODE_CRSEL */
	0,	/* SDL_SCANCODE_EXSEL */
	0,
	0,
	0,
	/* 0xa8 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	/* 0xb0 */
	ZKEY_0,	/* SDL_SCANCODE_KP_00 */
	ZKEY_0,	/* SDL_SCANCODE_KP_000 */
	ZKEY_COMMA,	/* SDL_SCANCODE_THOUSANDSSEPARATOR */
	ZKEY_PERIOD,	/* SDL_SCANCODE_DECIMALSEPARATOR */
	0,	/* SDL_SCANCODE_CURRENCYUNIT */
	0,	/* SDL_SCANCODE_CURRENCYSUBUNIT */
	ZKEY_LPAREN,	/* SDL_SCANCODE_KP_LEFTPAREN */
	ZKEY_RPAREN,	/* SDL_SCANCODE_KP_RIGHTPAREN */
	/* 0xb8 */
	ZKEY_LPAREN,	/* SDL_SCANCODE_KP_LEFTBRACE */
	ZKEY_RPAREN,	/* SDL_SCANCODE_KP_RIGHTBRACE */
	ZKEY_TAB,	/* SDL_SCANCODE_KP_TAB */
	ZKEY_BS,	/* SDL_SCANCODE_KP_BACKSPACE */
	ZKEY_A,	/* SDL_SCANCODE_KP_A */
	ZKEY_B,	/* SDL_SCANCODE_KP_B */
	ZKEY_C,	/* SDL_SCANCODE_KP_C */
	ZKEY_D,	/* SDL_SCANCODE_KP_D */
	/* 0xc0 */
	ZKEY_E,	/* SDL_SCANCODE_KP_E */
	ZKEY_F,	/* SDL_SCANCODE_KP_F */
	ZKEY_X,	/* SDL_SCANCODE_KP_XOR */
	0,	/* SDL_SCANCODE_KP_POWER */
	0,	/* SDL_SCANCODE_KP_PERCENT */
	0,	/* SDL_SCANCODE_KP_LESS */
	0,	/* SDL_SCANCODE_KP_GREATER */
	0,	/* SDL_SCANCODE_KP_AMPERSAND */
	/* 0xc8 */
	0,	/* SDL_SCANCODE_KP_DBLAMPERSAND */
	0,	/* SDL_SCANCODE_KP_VERTICALBAR */
	0,	/* SDL_SCANCODE_KP_DBLVERTICALBAR */
	ZKEY_COLON,	/* SDL_SCANCODE_KP_COLON */
	0,	/* SDL_SCANCODE_KP_HASH */
	ZKEY_SPC,	/* SDL_SCANCODE_KP_SPACE */
	0,	/* SDL_SCANCODE_KP_AT */
	0,	/* SDL_SCANCODE_KP_EXLAIM */
	/* 0xd0 */
	ZKEY_IN,	/* SDL_SCANCODE_KP_MEMSTORE */
	ZKEY_OUT,	/* SDL_SCANCODE_KP_MEMRECALL */
	0,	/* SDL_SCANCODE_KP_MEMCLEAR */
	0,	/* SDL_SCANCODE_KP_MEMADD */
	0,	/* SDL_SCANCODE_KP_MEMSUBTRACT */
	0,	/* SDL_SCANCODE_KP_MEMMULTIPLY */
	0,	/* SDL_SCANCODE_KP_MEMDIVIDE */
	0,	/* SDL_SCANCODE_KP_PLUSMINUS */
	/* 0xd8 */
	ZKEY_CLS,	/* SDL_SCANCODE_KP_CLEAR */
	ZKEY_CLS,	/* SDL_SCANCODE_KP_CLEARENTRY */
	0,	/* SDL_SCANCODE_KP_BINARY */
	0,	/* SDL_SCANCODE_KP_OCTAL */
	0,	/* SDL_SCANCODE_KP_DECIMAL */
	0,	/* SDL_SCANCODE_KP_HEXADECIMAL */
	0,
	0,
	/* 0xe0 */
	0,	/* SDL_SCANCODE_LCTRL */
	ZKEY_SHIFT,	/* SDL_SCANCODE_LSHIFT */
	0,	/* SDL_SCANCODE_LALT */
	0,	/* SDL_SCANCODE_LGUI */
	0,	/* SDL_SCANCODE_RCTRL */
	ZKEY_SHIFT,	/* SDL_SCANCODE_RSHIFT */
	0,	/* SDL_SCANCODE_RALT */
	0	/* SDL_SCANCODE_RGUI */
#elif SDL_MAJOR_VERSION == 1
	/* 0x00 */
	0,	/* SDLK_NONE */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	/* 0x08 */
	ZKEY_BS,	/* SDLK_BACKSPACE */
	ZKEY_TAB,	/* SDLK_TAB */
	0,
	0,
	ZKEY_CLS,	/* SDLK_CLEAR */
	ZKEY_RETURN,	/* SDLK_RETURN */
	0,
	0,
	/* 0x10 */
	0,
	0,
	0,
	ZKEY_BRK,	/* SDLK_PAUSE */
	0,
	0,
	0,
	0,
	/* 0x18 */
	0,
	0,
	0,
	ZKEY_OFF,	/* SDLK_ESCAPE */
	0,
	0,
	0,
	0,
	/* 0x20 */
	ZKEY_SPC,	/* SDLK_SPACE */
	0,	/* SDLK_EXCLAIM */
	0,	/* SDLK_QUOTEDBL */
	0,	/* SDLK_HASH */
	0,	/* SDLK_DOLLAR */
	0,
	0,	/* SDLK_AMPERSAND */
	ZKEY_COLON,	/* SDLK_QUOTE */
	/* 0x28 */
	ZKEY_LPAREN,	/* SDLK_LEFTPAREN */
	ZKEY_RPAREN,	/* SDLK_RIGHTPAREN */
	ZKEY_ASTER,	/* SDLK_ASTERISK */
	ZKEY_PLUS,	/* SDLK_PLUS */
	ZKEY_COMMA,	/* SDLK_COMMA */
	ZKEY_MINUS,	/* SDLK_MINUS */
	ZKEY_PERIOD,	/* SDLK_PERIOD */
	ZKEY_SLASH,	/* SDLK_SLASH */
	/* 0x30 */
	ZKEY_0,	/* SDLK_0 */
	ZKEY_1,	/* SDLK_1 */
	ZKEY_2,	/* SDLK_2 */
	ZKEY_3,	/* SDLK_3 */
	ZKEY_4,	/* SDLK_4 */
	ZKEY_5,	/* SDLK_5 */
	ZKEY_6,	/* SDLK_6 */
	ZKEY_7,	/* SDLK_7 */
	/* 0x38 */
	ZKEY_8,	/* SDLK_8 */
	ZKEY_9,	/* SDLK_9 */
	ZKEY_COLON,	/* SDLK_COLON */
	ZKEY_SEMICOLON,	/* SDLK_SEMICOLON */
	0,	/* SDLK_LESS */
	ZKEY_HAT,	/* SDLK_EQUALS */
	0,	/* SDLK_GREATER */
	0,	/* SDLK_QUESTION */
	/* 0x40 */
	0,	/* SDLK_AT */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	/* 0x48 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	/* 0x50 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	/* 0x58 */
	0,
	0,
	0,
	0,	/* SDLK_LEFTBRACKET */
	ZKEY_RPAREN,	/* SDLK_BACKSLASH */
	ZKEY_LPAREN,	/* SDLK_RIGHTBRACKET */
	0,	/* SDLK_CARET */
	0,	/* SDLK_UNDERSCORE */
	/* 0x60 */
	0,	/* SDLK_BACKQUOTE */
	ZKEY_A,	/* SDLK_A */
	ZKEY_B,	/* SDLK_B */
	ZKEY_C,	/* SDLK_C */
	ZKEY_D,	/* SDLK_D */
	ZKEY_E,	/* SDLK_E */
	ZKEY_F,	/* SDLK_F */
	ZKEY_G,	/* SDLK_G */
	/* 0x68 */
	ZKEY_H,	/* SDLK_H */
	ZKEY_I,	/* SDLK_I */
	ZKEY_J,	/* SDLK_J */
	ZKEY_K,	/* SDLK_K */
	ZKEY_L,	/* SDLK_L */
	ZKEY_M,	/* SDLK_M */
	ZKEY_N,	/* SDLK_N */
	ZKEY_O,	/* SDLK_O */
	/* 0x70 */
	ZKEY_P,	/* SDLK_P */
	ZKEY_Q,	/* SDLK_Q */
	ZKEY_R,	/* SDLK_R */
	ZKEY_S,	/* SDLK_S */
	ZKEY_T,	/* SDLK_T */
	ZKEY_U,	/* SDLK_U */
	ZKEY_V,	/* SDLK_V */
	ZKEY_W,	/* SDLK_W */
	/* 0x78 */
	ZKEY_X,	/* SDLK_X */
	ZKEY_Y,	/* SDLK_Y */
	ZKEY_Z,	/* SDLK_Z */
	0,
	0,
	0,
	0,
	ZKEY_BS,	/* SDLK_BACKSPACE */
	/* 0x80 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0x88 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0x90 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0x98 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xa0 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xa8 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xb0 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xb8 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xc0 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xc8 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xd0 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xd8 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xe0 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xe8 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xf0 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0xf8 */
	0, 0, 0, 0, 0, 0, 0, 0,
	/* 0x100 */
	ZKEY_0,	/* SDLK_0 */
	ZKEY_1,	/* SDLK_1 */
	ZKEY_2,	/* SDLK_2 */
	ZKEY_3,	/* SDLK_3 */
	ZKEY_4,	/* SDLK_4 */
	ZKEY_5,	/* SDLK_5 */
	ZKEY_6,	/* SDLK_6 */
	ZKEY_7,	/* SDLK_7 */
	/* 0x108 */
	ZKEY_8,	/* SDLK_8 */
	ZKEY_9,	/* SDLK_9 */
	ZKEY_PERIOD,	/* SDLK_KP_PERIOD */
	ZKEY_SLASH,	/* SDLK_KP_DEVIDE */
	ZKEY_ASTER,	/* SDLK_MULTIPLY */
	ZKEY_MINUS,	/* SDLK_MINUS */
	ZKEY_PLUS,	/* SDLK_PLUS */
	ZKEY_RETURN,	/* SDLK_ENTER */
	/* 0x110 */
	ZKEY_EQUAL,	/* SDLK_KP_EQUAL */
	ZKEY_UP,	/* SDLK_UP */
	ZKEY_DOWN,	/* SDLK_DOWN */
	ZKEY_RIGHT,	/* SDLK_RIGHT */
	ZKEY_LEFT,	/* SDLK_LEFT */
	ZKEY_INS,	/* SDLK_INSERT */
	ZKEY_CLS,	/* SDLK_HOME */
	0,
	/* 0x118 */
	0,	/* SDLK_PAGEUP */
	0,	/* SDLK_PAGEDOWN */
	0,	/* SDLK_F1 */
	0,	/* SDLK_F2 */
	0,	/* SDLK_F3 */
	0,	/* SDLK_F4 */
	0,	/* SDLK_F5 */
	0,	/* SDLK_F6 */
	/* 0x120 */
	0,	/* SDLK_F7 */
	0,	/* SDLK_F8 */
	0,	/* SDLK_F9 */
	0,	/* SDLK_F10 */
	0,	/* SDLK_F11 */
	0,	/* SDLK_F12 */
	0,	/* SDLK_F13 */
	0,	/* SDLK_F14 */
	/* 0x128 */
	0,	/* SDLK_F15 */
	0,
	0,
	0,
	0,	/* SDLK_NUMLOCK */
	ZKEY_CAPS,	/* SDLK_CAPSLOCK */
	0,	/* SDLK_SCROLLOCK */
	ZKEY_SHIFT,	/* SDLK_RSHIFT */
	/* 0x130 */
	ZKEY_SHIFT,	/* SDLK_LSHIFT */
	0,	/* SDLK_RCTRL */
	0,	/* SDLK_LCTRL */
	0,	/* SDLK_RLAT */
	0,	/* SDLK_LALT */
	0,	/* SDLK_RMETA */
	0,	/* SDLK_LMETA */
	0,	/* SDLK_LSUPER */
	/* 0x138 */
	0,	/* SDLK_RSUPER */
	0,	/* SDLK_MODE */
	0,	/* SDLK_COMPOSE */
	0,	/* SDLK_HELP */
	0,	/* SDLK_PRINT */
	0,	/* SDLK_SYSREQ */
	ZKEY_BRK,	/* SDLK_BREAK */
	ZKEY_MENU,	/* SDLK_MENU */
	/* 0x140 */
	0,	/* SDLK_POWER */
	0,	/* SDLK_EURO */
	0	/* SDLK_UNDO */
#endif
}
#endif
;

/* L[R[hϊe[u(ALT) */
EXTERN uint16 keyConvAlt[KEY_LAST + 1];

/* L[R[hϊe[u(CTRL) */
EXTERN uint16 keyConvCtrl[KEY_LAST + 1];

/* L[R[hϊe[u(SHIFT) */
EXTERN uint16 keyConvShift[KEY_LAST + 1];

#endif

/*
	Copyright 2009~2019 maruhiro
	All rights reserved. 

	Redistribution and use in source and binary forms, 
	with or without modification, are permitted provided that 
	the following conditions are met: 

	 1. Redistributions of source code must retain the above copyright notice, 
	    this list of conditions and the following disclaimer. 

	 2. Redistributions in binary form must reproduce the above copyright notice, 
	    this list of conditions and the following disclaimer in the documentation 
	    and/or other materials provided with the distribution. 

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
	FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
	THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
